/* arrow.c generated from arrow.psw
   by unix pswrap V1.009  Wed Apr 19 17:50:24 PDT 1989
 */

#include <dpsclient/dpsfriends.h>
#include <string.h>

#line 1 "arrow.psw"
/* -----Macro to draw arrows----- */

/*  Usage  x_tail y_tail x_tip y_tip tail_thick max_thick head_length join_length diff arrow */

/*    x_tail y_tail -> x y coordinates of the arrow's tail */
/*    x_tip y_tip -> x y coordinates of the arrow's head (may be modified with diff) */
/*    tail_thick -> thickness of the tail */
/*    max_thick -> thickness of the widest portion of the arrow head */
/*    head_length -> length of the arrow head at tips */
/*    join_length -> length of arrow head where it joins tail */
/*    diff -> reduces arrowlength holding tail position fixed by an amount diff.  Useful for */
/*	pointing at an object with a finite radius whose center is at x_tip y_tip so that the */
/*	arrowhead does not penetrate the object */
#line 23 "arrow.c"
void arrow(float tailx, float taily, float tipx, float tipy, float tailthick, float maxthick, float headlength, float joinlength, float diff)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjReal obj1;
    DPSBinObjReal obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjReal obj6;
    DPSBinObjReal obj7;
    DPSBinObjGeneric obj8;
    DPSBinObjGeneric obj9;
    DPSBinObjGeneric obj10;
    DPSBinObjGeneric obj11;
    DPSBinObjGeneric obj12;
    DPSBinObjGeneric obj13;
    DPSBinObjGeneric obj14;
    DPSBinObjGeneric obj15;
    DPSBinObjGeneric obj16;
    DPSBinObjGeneric obj17;
    DPSBinObjGeneric obj18;
    DPSBinObjReal obj19;
    DPSBinObjGeneric obj20;
    DPSBinObjGeneric obj21;
    DPSBinObjGeneric obj22;
    DPSBinObjGeneric obj23;
    DPSBinObjGeneric obj24;
    DPSBinObjGeneric obj25;
    DPSBinObjGeneric obj26;
    DPSBinObjGeneric obj27;
    DPSBinObjGeneric obj28;
    DPSBinObjReal obj29;
    DPSBinObjGeneric obj30;
    DPSBinObjGeneric obj31;
    DPSBinObjGeneric obj32;
    DPSBinObjGeneric obj33;
    DPSBinObjReal obj34;
    DPSBinObjGeneric obj35;
    DPSBinObjGeneric obj36;
    DPSBinObjGeneric obj37;
    DPSBinObjReal obj38;
    DPSBinObjGeneric obj39;
    DPSBinObjGeneric obj40;
    DPSBinObjGeneric obj41;
    DPSBinObjGeneric obj42;
    DPSBinObjReal obj43;
    DPSBinObjGeneric obj44;
    DPSBinObjGeneric obj45;
    DPSBinObjGeneric obj46;
    DPSBinObjReal obj47;
    DPSBinObjReal obj48;
    DPSBinObjGeneric obj49;
    DPSBinObjGeneric obj50;
    DPSBinObjGeneric obj51;
    DPSBinObjGeneric obj52;
    DPSBinObjGeneric obj53;
    DPSBinObjGeneric obj54;
    DPSBinObjGeneric obj55;
    DPSBinObjGeneric obj56;
    DPSBinObjGeneric obj57;
    DPSBinObjGeneric obj58;
    DPSBinObjGeneric obj59;
    DPSBinObjGeneric obj60;
    DPSBinObjGeneric obj61;
    DPSBinObjGeneric obj62;
    DPSBinObjGeneric obj63;
    DPSBinObjGeneric obj64;
    DPSBinObjGeneric obj65;
    DPSBinObjGeneric obj66;
    DPSBinObjGeneric obj67;
    DPSBinObjGeneric obj68;
    DPSBinObjGeneric obj69;
    DPSBinObjGeneric obj70;
    DPSBinObjGeneric obj71;
    DPSBinObjGeneric obj72;
    DPSBinObjGeneric obj73;
    DPSBinObjGeneric obj74;
    DPSBinObjGeneric obj75;
    DPSBinObjGeneric obj76;
    DPSBinObjGeneric obj77;
    DPSBinObjGeneric obj78;
    DPSBinObjGeneric obj79;
    DPSBinObjGeneric obj80;
    DPSBinObjGeneric obj81;
    DPSBinObjReal obj82;
    DPSBinObjGeneric obj83;
    DPSBinObjGeneric obj84;
    DPSBinObjReal obj85;
    DPSBinObjGeneric obj86;
    DPSBinObjGeneric obj87;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 88, 708,
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* dx */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: tipx */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: tailx */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 169},	/* sub */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* dy */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: tipy */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: taily */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 169},	/* sub */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* arrowlength */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* dx */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* dx */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 108},	/* mul */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* dy */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* dy */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 108},	/* mul */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 355},	/* sqrt */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: diff */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 169},	/* sub */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* angle */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* dy */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* dx */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 262},	/* atan */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* baseout */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* arrowlength */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: headlength */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 169},	/* sub */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* basein */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* arrowlength */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: joinlength */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 169},	/* sub */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* halfheadthickness */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: maxthick */
    {DPS_LITERAL|DPS_INT, 0, 0, 2},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 54},	/* div */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_NAME, 0, 0, 0},	/* halfthickness */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: tailthick */
    {DPS_LITERAL|DPS_INT, 0, 0, 2},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 54},	/* div */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: tailx */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: taily */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 173},	/* translate */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* angle */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 136},	/* rotate */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* halfthickness */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 110},	/* neg */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 107},	/* moveto */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* basein */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* halfthickness */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 110},	/* neg */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* baseout */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* halfheadthickness */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 110},	/* neg */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* arrowlength */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* baseout */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* halfheadthickness */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* basein */
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* halfthickness */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* halfthickness */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 22},	/* closepath */
    {DPS_LITERAL|DPS_INT, 0, 0, -1},
    {DPS_EXEC|DPS_NAME, 0, 0, 0},	/* angle */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 108},	/* mul */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 136},	/* rotate */
    {DPS_LITERAL|DPS_INT, 0, 0, -1},
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: tailx */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 108},	/* mul */
    {DPS_LITERAL|DPS_INT, 0, 0, -1},
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: taily */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 108},	/* mul */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 173},	/* translate */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  static long int _dpsCodes[29] = {-1};
  {
if (_dpsCodes[0] < 0) {
    static const char * const _dps_names[] = {
	"dx",
	(char *) 0 ,
	(char *) 0 ,
	(char *) 0 ,
	"dy",
	(char *) 0 ,
	(char *) 0 ,
	(char *) 0 ,
	"arrowlength",
	(char *) 0 ,
	(char *) 0 ,
	(char *) 0 ,
	"angle",
	(char *) 0 ,
	(char *) 0 ,
	"baseout",
	(char *) 0 ,
	(char *) 0 ,
	"basein",
	(char *) 0 ,
	(char *) 0 ,
	"halfheadthickness",
	(char *) 0 ,
	(char *) 0 ,
	"halfthickness",
	(char *) 0 ,
	(char *) 0 ,
	(char *) 0 ,
	(char *) 0 };
    long int *_dps_nameVals[29];
    _dps_nameVals[0] = &_dpsCodes[0];
    _dps_nameVals[1] = &_dpsCodes[1];
    _dps_nameVals[2] = &_dpsCodes[2];
    _dps_nameVals[3] = &_dpsCodes[3];
    _dps_nameVals[4] = &_dpsCodes[4];
    _dps_nameVals[5] = &_dpsCodes[5];
    _dps_nameVals[6] = &_dpsCodes[6];
    _dps_nameVals[7] = &_dpsCodes[7];
    _dps_nameVals[8] = &_dpsCodes[8];
    _dps_nameVals[9] = &_dpsCodes[9];
    _dps_nameVals[10] = &_dpsCodes[10];
    _dps_nameVals[11] = &_dpsCodes[11];
    _dps_nameVals[12] = &_dpsCodes[12];
    _dps_nameVals[13] = &_dpsCodes[13];
    _dps_nameVals[14] = &_dpsCodes[14];
    _dps_nameVals[15] = &_dpsCodes[15];
    _dps_nameVals[16] = &_dpsCodes[16];
    _dps_nameVals[17] = &_dpsCodes[17];
    _dps_nameVals[18] = &_dpsCodes[18];
    _dps_nameVals[19] = &_dpsCodes[19];
    _dps_nameVals[20] = &_dpsCodes[20];
    _dps_nameVals[21] = &_dpsCodes[21];
    _dps_nameVals[22] = &_dpsCodes[22];
    _dps_nameVals[23] = &_dpsCodes[23];
    _dps_nameVals[24] = &_dpsCodes[24];
    _dps_nameVals[25] = &_dpsCodes[25];
    _dps_nameVals[26] = &_dpsCodes[26];
    _dps_nameVals[27] = &_dpsCodes[27];
    _dps_nameVals[28] = &_dpsCodes[28];

    DPSMapNames(_dpsCurCtxt, 29, _dps_names, _dps_nameVals);
    }
  }

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[2].val.realVal =
  _dpsP[47].val.realVal =
  _dpsP[82].val.realVal = tailx;
  _dpsP[7].val.realVal =
  _dpsP[48].val.realVal =
  _dpsP[85].val.realVal = taily;
  _dpsP[1].val.realVal = tipx;
  _dpsP[6].val.realVal = tipy;
  _dpsP[43].val.realVal = tailthick;
  _dpsP[38].val.realVal = maxthick;
  _dpsP[29].val.realVal = headlength;
  _dpsP[34].val.realVal = joinlength;
  _dpsP[19].val.realVal = diff;
  _dpsP[0].val.nameVal = _dpsCodes[0];
  _dpsP[24].val.nameVal = _dpsCodes[1];
  _dpsP[12].val.nameVal = _dpsCodes[2];
  _dpsP[11].val.nameVal = _dpsCodes[3];
  _dpsP[5].val.nameVal = _dpsCodes[4];
  _dpsP[23].val.nameVal = _dpsCodes[5];
  _dpsP[15].val.nameVal = _dpsCodes[6];
  _dpsP[14].val.nameVal = _dpsCodes[7];
  _dpsP[10].val.nameVal = _dpsCodes[8];
  _dpsP[64].val.nameVal = _dpsCodes[9];
  _dpsP[33].val.nameVal = _dpsCodes[10];
  _dpsP[28].val.nameVal = _dpsCodes[11];
  _dpsP[22].val.nameVal = _dpsCodes[12];
  _dpsP[78].val.nameVal = _dpsCodes[13];
  _dpsP[50].val.nameVal = _dpsCodes[14];
  _dpsP[27].val.nameVal = _dpsCodes[15];
  _dpsP[67].val.nameVal = _dpsCodes[16];
  _dpsP[60].val.nameVal = _dpsCodes[17];
  _dpsP[32].val.nameVal = _dpsCodes[18];
  _dpsP[70].val.nameVal = _dpsCodes[19];
  _dpsP[56].val.nameVal = _dpsCodes[20];
  _dpsP[37].val.nameVal = _dpsCodes[21];
  _dpsP[68].val.nameVal = _dpsCodes[22];
  _dpsP[61].val.nameVal = _dpsCodes[23];
  _dpsP[42].val.nameVal = _dpsCodes[24];
  _dpsP[74].val.nameVal = _dpsCodes[25];
  _dpsP[71].val.nameVal = _dpsCodes[26];
  _dpsP[57].val.nameVal = _dpsCodes[27];
  _dpsP[53].val.nameVal = _dpsCodes[28];
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,708);
}
#line 44 "arrow.psw"
